var trainType = 0; //上次使用最后打开的是习题一还是习题二
var init_Index = 0; // 上次使用最后打开的句子【习题一】
var learnEnd = []; //已学句子标红设置【习题一】
var learnNum = 0; //已经学习的句子和答过的习题数目
var lastIndex = -1, curIndex = -1; //记录上次打开和当前打开的句子
var pageObj = {}; //记录pageID项目下设置的对象
var swiperMain,trainingTwo; //swiper对象
var isSwipering; //是否正在切换中 【习题二】
var proMask = {}; //每一题进度统计状态标记 【习题二】
var optionArray = ["A","B","C","D","E","F","G"]; //选项表

$(function(){
	init(); //调用全局初始化函数
	function init(){
		FastClick.attach(document.body);

		//定义框架尺寸
		$(window).on('resize',fixPageHeight);
		fixPageHeight();

		//初始化滑动组件
		swiperMain = new Swiper('.swiper-main',{
			noSwiping : true,
			onSlideChangeStart: function(swiper){
				$('#nav span').removeClass('active');
				$('#navbtn'+swiper.activeIndex).addClass('active');
				trainType = swiper.activeIndex;
				pageObj.trainType = trainType;
				setStorage({"key":paperID, "value":pageObj});
			}
		});
		trainingTwo = new Swiper('#trainingTwo',{
			noSwiping : false,
			mousewheelControl : true,
			direction: 'horizontal',
		    onSlideChangeStart: function(swiper){
		    	isSwipering = 1;
		    	trainingTwo.detachEvents();  //滑动锁定与延时解锁
		    	if(trainingTwo.activeIndex == 2){
		    		$('#currentKt').html(currKtIndex+2);
		    	}
		    	else if(trainingTwo.activeIndex == 0) {
		    		$('#currentKt').html(currKtIndex);
		    	}
		    	else {
		    		if(currKtIndex){
		    			$('#currentKt').html(currKtIndex);
		    		}
		    		else {
		    			$('#currentKt').html(currKtIndex+2);
		    		}
		    	}
		    },
		    onSlideChangeEnd: function(swiper){
		    	isSwipering = 0;
		    	setTimeout(function(){
		    		trainingTwo.attachEvents();  //滑动锁定与延时解锁
		    	},100);
			    if(trainingTwo.isEnd){
			      	swiperToEnd();
			    }
			    else if(trainingTwo.isBeginning){
			    	swiperToBeginning();
			    }
			    else {
			    	//滑动至中间一页
			    	if(currKtIndex == 0){
			    		currKtIndex++;
						var jsonD = {'paperID': paperID, "currKtIndex": currKtIndex};
						saveCurrKtIndex(jsonD);
			    	}
			    	else if(currKtIndex == (ktList.length-1)){
			    		currKtIndex--;
						var jsonD = {'paperID': paperID, "currKtIndex": currKtIndex};
						saveCurrKtIndex(jsonD);
			    	}
			    	else {
			    		// alert('滑动至中间页异常！');
			    	}
			    }
		    },
		    onSliderMove: function(swiper, event){
		    	$('#ktSerial').addClass('show');
		    },
		    onTouchEnd: function(swiper){
		        setTimeout(function(){
		        	$('#ktSerial').removeClass('show');
		        }, 300);
		    }
		});
		
		settingInit(); // 页面设置初始化

		//为每条句子绑定click事件
		$('.wordExercise').on('click',function(){
			showSentence(this);
		});

		//绑定nav点击事件
		$('#nav span').on('click',function(){
			swiperMain.slideTo($(this).attr('index'),300);
		});

		//根据currKtIndex 确定页面载入时滑动到哪一页暂停
		var maxKtIndex = ktList.length - 1;
		if((currKtIndex > 0) && (currKtIndex < maxKtIndex)){
			trainingTwo.slideTo(1, 0, false);
		}
		else if(currKtIndex == maxKtIndex){
			trainingTwo.slideTo(2, 0, false);
		}

		//初始化绑定选项点击事件
		$('.mylabel').on("click",labelClickAction);

	}

	//页面设置初始化
	function settingInit(){
		getStorage({"key":paperID, "successCallback":"onPageID"});
		//读取localStorage数据以初始化paperAnswer
		var jsonD = {};
		jsonD.key = paperID + "_*";
		jsonD.successCallback = "getAllAnswer";
		getStorage(jsonD);
	}
	//框架尺寸调整方法
	function fixPageHeight(){
		var height = $(window).height() - $('#nav').height();
		$(".swiper-main").css('height', height);
		var newHeight = height - $('.descriptionOne').height();
		$("#trainingTwo").css('height', newHeight);
		$(".innerContent").css('height', newHeight);
	}

	
	//滑动到下一题方法
	function swiperToEnd(){
		//更新并保存 currKtIndex
		currKtIndex++;
		//追加页面
		var serNum = currKtIndex+1; //习题序号
		var htmlText = '', ktID = ktList[serNum];
		if(ktID){
			var data = ktData[serNum][0];
			if(data){
				htmlText = assembleHtml(data,ktID,serNum);
			}
			trainingTwo.appendSlide(htmlText);
			setTimeout(function(){
				trainingTwo.removeSlide(0);
			},100);
	        //绑定点击事件
	        labelClick(ktID);
		}        
        //向客户端保存currKtIndex
        var jsonD = {'paperID': paperID, "currKtIndex": currKtIndex};
		saveCurrKtIndex(jsonD);
	}
	//滑动到上一题方法
	function swiperToBeginning(){
		//更新并保存 currKtIndex
		currKtIndex--;		
		//追加页面
		var serNum = currKtIndex-1; //习题序号
		var htmlText = '', ktID = ktList[serNum];
		if(ktID){
			var data = ktData[serNum][0];
			var reRequertData = 0;
			if(data){
				htmlText = assembleHtml(data,ktID,serNum);
			}
			trainingTwo.removeSlide(2);
			setTimeout(function(){
				trainingTwo.prependSlide(htmlText);
				//绑定点击事件
		        labelClick(ktID);
			}, 100);
		}
        //向客户端保存currKtIndex
        var jsonD = {'paperID': paperID, "currKtIndex": currKtIndex};
		saveCurrKtIndex(jsonD);
	}

	//为特定页面选项绑定点击事件
	function labelClick(id){
		$('#'+id).find('.mylabel').on("click",labelClickAction);
	}
	//习题二选项点击事件
	function labelClickAction(){
		if(!isSwipering){
			var ktID = ktList[currKtIndex];
			var key = paperID +'_'+ ktID;
			var answer = ktData[currKtIndex][0].answer;
			if($(this).attr('class') == 'mylabel'){
				$(this).parent().find('.mylabel').removeClass('right wrong');
				paperAnswer[key] = $(this).attr('key');
				if(paperAnswer[key] == answer){
					$(this).addClass('right');
					$(this).parent().next().removeClass('show');
				}
				else {
					$(this).addClass('wrong');
					$(this).parent().next().addClass('show');
				}
			}
			else {
				$(this).removeClass('right wrong');
				paperAnswer[key] = '';
				$(this).parent().next().removeClass('show');
			}
			
			//保存答案到localStorage中
			setStorage({"key":key, "value":paperAnswer[key]});
			//更新学习进度
			if(paperAnswer[key] && !proMask[key]){
				learnNum++;
				proMask[key] = 1;
				$('#progress').css({'-webkit-transform': 'scaleX('+learnNum/ktNum+')'});
				if(learnNum==ktNum){
					$('#progress').addClass('full');
				}
				//反馈当前习题解答状况给客户端
				refreshStudyStatus({"uwid":ktID, "state":"1"});
			}
			else if(!paperAnswer[key]){
				if(learnNum==ktNum){
					$('#progress').removeClass('full');
				}
				learnNum--;
				proMask[key] = 0;
				$('#progress').css({'-webkit-transform': 'scaleX('+learnNum/ktNum+')'});
				//反馈当前习题解答状况给客户端
				refreshStudyStatus({"uwid":ktID, "state":"0"});
			}
		}
	}
});

//组装数据通用代码方法
function assembleHtml(data,ktID,serNum){
	var htmlText = '';
	htmlText = '<div class="swiper-slide" id="'+ ktID +'">';
	htmlText += assembleInnerHtml(data,ktID,serNum);
	htmlText += '</div>';
	return htmlText;
}
//拼装swiper-slide内部html文本
function assembleInnerHtml(data,ktID,serNum){
	var key = paperID+'_'+ktID;
	var htmlText = '<div class="dropShadow"></div><div class="innerCard"><div class="testTitle"><div class="testNum">'+ (serNum+1) +'</div><div class="testTitleCon">'+ data.question +'</div></div><div class="testOption">';
	var Data = data.option;
	for(var i=0; i<optionArray.length; i++){
		if(Data[optionArray[i]]){
			if(paperAnswer[key] && (paperAnswer[key] == optionArray[i])) {
				if(paperAnswer[key] == data.answer){
					htmlText += '<div class="mylabel right" key="'+ optionArray[i] +'"><span>'+ optionArray[i] +'</span>'+ Data[optionArray[i]] +'</div>';
				}
				else {
					htmlText += '<div class="mylabel wrong" key="'+ optionArray[i] +'"><span>'+ optionArray[i] +'</span>'+ Data[optionArray[i]] +'</div>';
				}
			}
			else {
				htmlText += '<div class="mylabel" key="'+ optionArray[i] +'"><span>'+ optionArray[i] +'</span>'+ Data[optionArray[i]] +'</div>';
			}
		}
		else {
			break;
		}
	}
	htmlText += '</div><p class="rightAnswer';
	if(paperAnswer[key] && (paperAnswer[key] != data.answer)){
		htmlText += ' show';
	}
	htmlText += '">正确答案是: <span class="rightColor">'+ data.answer +'</span></p></div>';
	return htmlText;
}

//获取全部答案后初始化
function getAllAnswerInit(){
	// 初始化进度统计
    for(var i in paperAnswer){
        if(paperAnswer[i]){
            learnNum++;
            proMask[i] = 1;
        }
    }
    $('#progress').css({'-webkit-transform': 'scaleX('+learnNum/ktNum+')'});
    if(learnNum == ktNum){
        $('#progress').addClass('full');
    }
    //更新当前页面三道题的答案状态
    $('#trainingTwo .swiper-slide').each(function(){
        var ktID = $(this).attr('id');
        var key = paperID +'_'+ ktID;
        if(paperAnswer[key]){
            $(this).find('.mylabel').each(function(){
                if(paperAnswer[key] == $(this).attr('key')){
                	if($(this).find('answer').length){
                		$(this).addClass('right');
                	}
                	else {
                		$(this).addClass('wrong');
                		$(this).parent().next().addClass('show');
                	}
                }
            });
        }
    });
}

//获取当前页面ID对应参数后初始化
function pageIDInit(json){
	if(!json.value){
        for(var i = 0; i < $('.wordExercise').length; i++){
            learnEnd[i] = 0;
        }
        pageObj.learnEnd = learnEnd;
        pageObj.init_Index = init_Index;
        pageObj.trainType = trainType;
        setStorage({"key":paperID, "value":pageObj});
    }
    else {
        var pageSet = parseJson(json.value);
        init_Index = pageSet.init_Index;
        learnEnd = pageSet.learnEnd;
        trainType = pageSet.trainType;

        //初始化 pageObj
        pageObj.learnEnd = learnEnd;
        pageObj.init_Index = init_Index;
        pageObj.trainType = trainType;
    }
    //更新已学过的习题一样式
    for(var j in learnEnd){
        if(learnEnd[j] == 1){
            $($('.wordExercise')[j]).addClass('read');
            learnNum++;
        }
    }
    $('#progress').css({'-webkit-transform': 'scaleX('+learnNum/ktNum+')'});
    if(learnNum == ktNum){
        $('#progress').addClass('full');
    }
    
    //根据用户上次打开的句子跳转
    if (init_Index >= 0) {
        showSentence($('.wordExercise')[init_Index]);
        click_scroll($('.wordExercise')[init_Index]);
    }

    //根据 trainType 跳转习题类型
    if(trainType){
    	swiperMain.slideTo(trainType,300);
    }
}
//页面跳转
function click_scroll(aim) {
	var scroll_offset = $(aim).offset().top-$(aim).height();
	$(".innerContent").scrollTop(scroll_offset);
}

//习题一展开单词
function showSentence(sen){
	lastIndex = curIndex;
    curIndex = $(sen).index();
    //判断两次点击是否是同一条句子，分情况处理
    if(curIndex == lastIndex){
        $(sen).removeClass('active');
        curIndex = -1;
    }
    else {
    	$($('.wordExercise')[lastIndex]).removeClass('active');
    	$(sen).addClass('active read');
    	if(!learnEnd[curIndex]){
    		learnEnd[curIndex] = 1;
	        learnNum++;
	        $('#progress').css({'-webkit-transform': 'scaleX('+learnNum/ktNum+')'});
	        if(learnNum == ktNum){
	            $('#progress').addClass('full');
	        }
    	}
    }
	init_Index = curIndex;
    pageObj.init_Index = init_Index;
    pageObj.learnEnd = learnEnd;
    setStorage({"key":paperID, "value":pageObj});
    //反馈当前打开词条信息给客户端
    var json = {};
    json.id = paperID;
    json.uwid = $(sen).attr('id');
    refreshStudyStatus(json);
}